## Concetti

Un disco, prima di essere utilizzato deve essere partizionato. Una *partizione* e' un sottoinsieme logico del disco fisico. Le informazioni sulle partizioni sono archiviate nella *tabella delle partizioni*. Include informazioni sul primo e ultimo settore della partizione e sul suo tipo. All'interno di ogni partizione c'e' un *filesystem*, che descrive il modo in cui le informazioni sono memorizzate sul disco. 

## Punto di mount

Prima di accedere a un filesystem, questo deve essere *montato*. Il punto di montaggio deve esistere prima di montare il filesystem. Se esiste e contiene file, questi non saranno disponibili fino a che il filesystem non sara' smontato. `/media/` e' il punto di montaggio predefinito per qualsiasi supporto rimovibile. Ogni volta che si monta *manualmente* un filesystem, e' buona norma montarlo in `/mnt/`.

## Partizioni

### /boot

La partizione di avvio, contiene i file usati dal bootloader per caricare il SO. I file di configurazione di GRUB2 si trovano in `/boot/grub/`. E' in genere la prima partizione sul disco. La partizione di avvio si trova all'inizio del disco e termina prima del cilindro 1024 (528 MB).

### ESP

Utilizzata dalle macchine basate su EUFI per memorizzare il bootloader, solitamente formattata in FAT32. Viene montata in `/boot/efi`.

### /var

Contiene *dati variabili* o file e directory su cui il sistema deve poter scrivere durante il funzionamento. Cio' include i log di sistema (`/var/log`), i file temporanei (`/var/tmp`) e file di cache (`/var/cache`).

### swap

Utilizzata per scambiare pagine di memoria dalla RAM al disco secondo necessita'. Non puo' essere montata come le altre, il che significa che non e' possibile accedervi come con una normale directory e osservarne il contenuto. Linux supporta anche file di swap, utili per aumentare rapidamente lo spazio di swap. 

## LVM

*Logical Volume Management* e' una forma di virtualizzazione dello storage che offre una maggior flessibilita' nella gestione dello spazio disco. 

L'unita' base e' il *Physical Volume* (PV). I PV sono raggruppati in *Volume Group* (VG) che astraggono i dispositivi sottostanti e sono visti dal SO come un unico dispositivo logico.

Ogni volume in un VG e' suddiviso in parti di dimensioni fisse chiamate *extents*. Tali parti su un PV sono denominate *Physical Extents* (PE), mentre su un LV sono denominate LE.

I VG possono essere suddivisi in *Logical Volumes* (LV), che sono simili alle partizioni, ma hanno maggior flessibilita'.

```txt
dim LV = numero extents sul volume X dimensione singola extents (4MB)
```

Nel SO viene visualizzato come un normale dispositivo a blocchi, nella forma: `/dev/VGNAME/LVNAME`. 