# Comandi utili

- **apropos**: se non si ricorda il nome esatto di un comando, si puo' utilizzare *apropos* per ricercare tra i nomi e le descrizioni delle pagine man.
- **pwd**: visualizza la directory di lavoro corrente
- **uname**: visualizza informazioni sul sistema
- **man**: permette di accedere alla documentazione sui comandi
- **type**: visualizza la posizione nel filesystem *e il tipo* di uno o piu' comandi

```bash
type gs
gs ha "git status" come alias

type uname
uname è /usr/bin/uname
```
- **which**: visualizza la posizione nel filesystem di un comando
- **lsblk**: elenca i dispositivi a blocchi
- **bzcat**: permette la lettura di file compressi tramite il metodo bzip2
- **xzcat**: xz
- **zcat**: gzip
- **nl**: *number line*, visualizza il numero di linee di un file, anteponendo il numero ad ogni riga
- **tr**: *translate*, permette di sostituire caratteri
- **cut**: estrapola parti di testo come se fossero campi, identificandoli tramite un delimitatore
- **paste**: unisce i file in colonne
- **cat**: funziona anche con dati binari, come l'invio del contenuto di un dispositivo a blocchi a un file (o per unire diversi file video in un unico grande file)

### rm

Il comando `rm` (remove) è utilizzato per rimuovere file e directory

```bash
rm [options] <File(s)>
```

Le opzioni principali:

- `-r` o `-R`: per rimuovere ricorsivamente directory e i loro contenuti
- `-f`: Rper rimuovi file forzatamente, senza chiedere conferma
- `-i`: rimozione interattiva. Richiede conferma prima di rimuovere ogni file
- `-v`: modalità verbosa
- `--preserve-root`: evita la rimozione della directory radice ('/') e dei suoi contenuti
- `--no-preserve-root`: Consente la rimozione della directory radice ('/') e dei suoi contenuti

### wget

```bash
wget [options] <URL>
```

#### Specificare il nome del file

```bash
wget -O <Filename> <URL>
```

#### Scaricare file in una directory specifica 

```bash
wget -P /path/to/download <URL>
```

#### Scaricare in background

```bash
wget -b <URL>
```

#### Scaricamento multiplo

```bash
nano wget.txt
wget -i Filename
```

### Riprendere i download

```bash
wget -c <URL>
```