# Ricercare file

Il comando principale si chiama `find`. Le opzioni per la ricerca di file in base al tipo sono:

- `-type f`: file
- `-type d`: directory
- `-type l`: link simbolici

Ad esempio: `find . -name "example" -type f`.

Altri criteri da utilizzare nella ricerca:

- `-iname`: ricerca in base al nome, non considerando lettere maiuscole o minuscole
- `-not`: restituisce i risultati che non corrispondono
- `-maxdepth N`: ricerca nelle sottodirectory fino a N livelli di profondiota'

### Dimensione

```bash
find . -iname "example" -size 2G -type f
```
- `-size 100M`: file che corrispondono esattamente a 100Mb 
- `-size +100M`: file piu' grandi di 100Mb 
- `-size -20M`: file piu' piccoli di 20Mb 
- `-size +2G`: file piu' grandi di 2Gb 

### Agire sui risultati

E' possibile eseguire delle azioni sui risultati usando l'opzione `-exec`:

```bash
find . -name "*.conf" -exec chmod 644 '{}' \;
```

