# Archiviazione dei file

Il comando `tar` e' utilizzato per creare archivi di file. 

```bash
tar [OPERATION and OPTIONS] [ARCHIVE NAME] [FILES]
```

Le operazioni principali sono:

- `-c`: crea un nuovo archivio
- `-x`: estrae un archivio
- `-t`: list, visualizza l'elenco dei file inclusi nell'archivio
- `-f nome_archivio`: specifica il nome dell'archivio
- `-v`: verbose

### Creazione di un archivio

`tar -cvf archive.tar file1 file2 directory1`

### Estrarre un archivio

`tar -xvf archive.tar`

Per estrarre il contenuto in una directory specifica usare l'opzione `-C`: `tar -xvf archive.tar -C /tmp`

### Comprimere un archivio

- `tar -czvf archive.tar.gz file1 file2`: gzip
- `tar -cjvf archive.tar.bz file1 file2`: bzip2. Piu' lento, ma con maggior compressione
  
## dd

```bash
dd if=oldfile of=newfile status=progress
```

copia i dati da una posizione all'altra.

