# VLAN

Gli host all'interno della stessa rete locale possono comunicare tra loro grazie a dispositivi di rete di livello 2, come switch, hub e AP.

Le VLAN (Virtual Local Area Network) sono utilizzate per partizionare e segmentare una rete locale, creando diverse sottoreti logiche. Questo approccio offre numerosi vantaggi, principalmente in termini di sicurezza: separando le reti, si isolano le comunicazioni tra i vari dispositivi, creando ambienti distinti.

Inoltre, le VLAN permettono di implementare politiche di sicurezza più granulari e specifiche attraverso l'uso di firewall, che possono applicare regole di traffico diverse tra le varie VLAN.

Sebbene sia possibile ottenere una segmentazione simile senza l'uso delle VLAN, utilizzando più dispositivi fisici come switch, l'adozione delle VLAN consente di raggiungere gli stessi obiettivi a livello software, riducendo i costi e semplificando la gestione della rete.

Per assegnare i membri a una VLAN, si configurano le porte dello switch. Assegnando le porte a specifiche VLAN, si realizza la segmentazione desiderata.

## Configurazione VLAN Switch CISCO

Ad esempio, per configurare le interfacce 1 e 2 di uno switch nella VLAN 10

```txt
switch> ena
switch# conf t
switch(config)# interface range fastEthernet0/1-2
switch(if-range)# switchport mode access 
switch(if-range)# switchport access vlan 10
switch(if-range)# end
switch# show vlan brief # Visualizza un riepilogo della configurazione VLAN
switch# write
```

È importante notare che esiste sempre una VLAN nativa, la VLAN 1, che per impostazione predefinita include tutte le interfacce dello switch.

Dopo aver creato le VLAN, è necessario procedere con la segmentazione delle reti, ovvero il subnetting. Per consentire la comunicazione tra due o più reti distinte, è necessario utilizzare dispositivi di livello 3, come i router. Questi dispositivi sono responsabili dell'instradamento del traffico tra le VLAN, garantendo che i pacchetti possano viaggiare tra le diverse sottoreti.
